# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_disk`](#dsc_disk): The DSC Disk resource type. Automatically generated from version 5.0.1
* [`dsc_diskaccesspath`](#dsc_diskaccesspath): The DSC DiskAccessPath resource type. Automatically generated from version 5.0.1
* [`dsc_mountimage`](#dsc_mountimage): The DSC MountImage resource type. Automatically generated from version 5.0.1
* [`dsc_opticaldiskdriveletter`](#dsc_opticaldiskdriveletter): The DSC OpticalDiskDriveLetter resource type. Automatically generated from version 5.0.1
* [`dsc_waitfordisk`](#dsc_waitfordisk): The DSC WaitForDisk resource type. Automatically generated from version 5.0.1
* [`dsc_waitforvolume`](#dsc_waitforvolume): The DSC WaitForVolume resource type. Automatically generated from version 5.0.1

## Resource types

### `dsc_disk`

The DSC Disk resource type.
Automatically generated from version 5.0.1

#### Properties

The following properties are available in the `dsc_disk` type.

##### `dsc_allocationunitsize`

Data type: `Optional[Integer[0, 4294967295]]`

%q{
        Specifies the allocation unit size to use when formatting the volume.
      }

##### `dsc_allowdestructive`

Data type: `Optional[Boolean]`

%q{
        Specifies if potentially destructive operations may occur.
      }

##### `dsc_cleardisk`

Data type: `Optional[Boolean]`

%q{
        Specifies if the disks partition schema should be removed entirely, even if data and OEM partitions are present. Only possible with AllowDestructive enabled.
      }

##### `dsc_diskid`

Data type: `String`

%q{
        Specifies the disk identifier for the disk to modify.
      }

##### `dsc_diskidtype`

Data type: `Optional[Enum['Number', 'UniqueId', 'Guid', 'Location']]`

%q{
        Specifies the identifier type the DiskId contains. Defaults to Number.
      }

##### `dsc_fsformat`

Data type: `Optional[Enum['NTFS', 'ReFS']]`

%q{
        Specifies the file system format of the new volume.
      }

##### `dsc_fslabel`

Data type: `Optional[String]`

%q{
        Define volume label if required.
      }

##### `dsc_partitionstyle`

Data type: `Optional[Enum['MBR', 'GPT']]`

%q{
        Specifies the partition style of the disk. Defaults to GPT.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_size`

Data type: `Optional[Integer[0, 18446744073709551615]]`

%q{
        Specifies the size of new volume. Leave empty to use the remaining free space.
      }

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: `present`

#### Parameters

The following parameters are available in the `dsc_disk` type.

##### `dsc_driveletter`

namevar

Data type: `String`

%q{
        Specifies the identifier for which disk to modify.
      }

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_diskaccesspath`

The DSC DiskAccessPath resource type.
Automatically generated from version 5.0.1

#### Properties

The following properties are available in the `dsc_diskaccesspath` type.

##### `dsc_allocationunitsize`

Data type: `Optional[Integer[0, 4294967295]]`

%q{
        Specifies the allocation unit size to use when formatting the volume.
      }

##### `dsc_diskid`

Data type: `String`

%q{
        Specifies the disk identifier for the disk to modify.
      }

##### `dsc_diskidtype`

Data type: `Optional[Enum['Number', 'UniqueId', 'Guid', 'Location']]`

%q{
        Specifies the identifier type the DiskId contains. Defaults to Number.
      }

##### `dsc_fsformat`

Data type: `Optional[Enum['NTFS', 'ReFS']]`

%q{
        Specifies the file system format of the new volume.
      }

##### `dsc_fslabel`

Data type: `Optional[String]`

%q{
        Define volume label if required.
      }

##### `dsc_nodefaultdriveletter`

Data type: `Optional[Boolean]`

%q{
        Specifies no automatic drive letter assignment to the partition: Defaults to True
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_size`

Data type: `Optional[Integer[0, 18446744073709551615]]`

%q{
        Specifies the size of new volume.
      }

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: `present`

#### Parameters

The following parameters are available in the `dsc_diskaccesspath` type.

##### `dsc_accesspath`

namevar

Data type: `String`

%q{
        Specifies the access path folder to the assign the disk volume to.
      }

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_mountimage`

The DSC MountImage resource type.
Automatically generated from version 5.0.1

#### Properties

The following properties are available in the `dsc_mountimage` type.

##### `dsc_access`

Data type: `Optional[Enum['ReadOnly', 'ReadWrite']]`

%q{
        Allows a VHD file to be mounted in read-only or read-write mode. ISO files are mounted in read-only mode regardless of what parameter value you provide.
      }

##### `dsc_driveletter`

Data type: `Optional[String]`

%q{
        Specifies the drive letter to mount this VHD or ISO to.
      }

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

%q{
        Determines whether the VHD or ISO should be mounted or not.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_storagetype`

Data type: `Optional[Enum['ISO', 'VHD', 'VHDx', 'VHDSet']]`

%q{
        Specifies the storage type of a file. If the StorageType parameter is not specified, then the storage type is determined by file extension.
      }

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: `present`

#### Parameters

The following parameters are available in the `dsc_mountimage` type.

##### `dsc_imagepath`

namevar

Data type: `String`

%q{
        Specifies the path of the VHD or ISO file.
      }

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_opticaldiskdriveletter`

The DSC OpticalDiskDriveLetter resource type.
Automatically generated from version 5.0.1

#### Properties

The following properties are available in the `dsc_opticaldiskdriveletter` type.

##### `dsc_driveletter`

Data type: `String`

%q{
        Specifies the drive letter to assign to the optical disk. Can be a single letter, optionally followed by a colon. This value is ignored if Ensure is set to Absent.
      }

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

%q{
        Determines whether a drive letter should be assigned to the optical disk. Defaults to 'Present'.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: `present`

#### Parameters

The following parameters are available in the `dsc_opticaldiskdriveletter` type.

##### `dsc_diskid`

namevar

Data type: `String`

%q{
        Specifies the optical disk number for the disk to assign the drive letter to.
      }

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_waitfordisk`

The DSC WaitForDisk resource type.
Automatically generated from version 5.0.1

#### Properties

The following properties are available in the `dsc_waitfordisk` type.

##### `dsc_diskidtype`

Data type: `Optional[Enum['Number', 'UniqueId', 'Guid', 'Location']]`

%q{
        Specifies the identifier type the DiskId contains. Defaults to Number.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

%q{
        The number of times to loop the retry interval while waiting for the disk.
      }

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 4294967295]]`

%q{
        Specifies the number of seconds to wait for the disk to become available.
      }

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: `present`

#### Parameters

The following parameters are available in the `dsc_waitfordisk` type.

##### `dsc_diskid`

namevar

Data type: `String`

%q{
        Specifies the disk identifier for the disk to wait for.
      }

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_waitforvolume`

The DSC WaitForVolume resource type.
Automatically generated from version 5.0.1

#### Properties

The following properties are available in the `dsc_waitforvolume` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

%q{
        The number of times to loop the retry interval while waiting for the volume.
      }

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 4294967295]]`

%q{
        Specifies the number of seconds to wait for the volume to become available.
      }

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: `present`

#### Parameters

The following parameters are available in the `dsc_waitforvolume` type.

##### `dsc_driveletter`

namevar

Data type: `String`

%q{
        Specifies the drive letter of the volume to wait for.
      }

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

